#include "priv.h"

#include "resource.h"
#include "definition.h"
#include "Dlg.h"
#include "util.h"
#include "Language.h"

// external declaration
extern INITSTRUCT gParam;
extern CLanguage    *lng;


/* ************************************************************************ */
BOOL CDlgMatchTime::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		InitLanguage();
		SendDlgItemMessage(m_hDlg, IDC_EDIT_MATCHTIME, EM_SETLIMITTEXT , 3L, 0L);
		CheckRadioButton(m_hDlg, IDC_RADIOMATCHTIME1, IDC_RADIOMATCHTIME7, IDC_RADIOMATCHTIME1 +  gParam.nMatchTime) ; 
		EnableWindow(GetDlgItem(m_hDlg,IDC_EDIT_MATCHTIME), (gParam.nMatchTime == 6));
		return FALSE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDC_RADIOMATCHTIME1:
		case IDC_RADIOMATCHTIME2:
		case IDC_RADIOMATCHTIME3:
		case IDC_RADIOMATCHTIME4:
		case IDC_RADIOMATCHTIME5:
		case IDC_RADIOMATCHTIME6:
			EnableWindow(GetDlgItem(m_hDlg,IDC_EDIT_MATCHTIME), FALSE);
			gParam.nMatchTime = LOWORD(wParam) - IDC_RADIOMATCHTIME1;
			return TRUE;
		case IDC_RADIOMATCHTIME7:
			EnableWindow(GetDlgItem(m_hDlg,IDC_EDIT_MATCHTIME), TRUE);
			gParam.nMatchTime = 6;
			return TRUE;

		
		case IDOK:
			{
				int length_minute[6] = {45,60,74,80,90,120};
				int length_second;

				if (gParam.nMatchTime == 6)
				{
					TCHAR szCustom[4];
					GetWindowText(GetDlgItem(m_hDlg, IDC_EDIT_MATCHTIME), (LPTSTR)szCustom, 4);
		
					
					length_second = _ttoi(szCustom);
					if (length_second ==0)
					{
						MessageBox(m_hDlg, GS(LNG_MSG_TIME_MUSTBENOTNULL), GS(LNG_ERROR), MB_OK | MB_ICONSTOP);
						return FALSE;
					}
					length_second *= 60;

				}
				else
					length_second = length_minute[gParam.nMatchTime] * 60;

				
				EndDialog(m_hDlg, length_second);
				return TRUE;
			}

		case IDCANCEL:
			EndDialog(m_hDlg, 0);
			return TRUE;

		
		}
		
	}
	return FALSE;
}

// **********************************************
void CDlgMatchTime::InitLanguage()
{
	LNGRESSTRUCT lrs[10] = 
	{
		{ R_MEDIA_FRAME, LNG_MEDIA_FRAME },
		{ IDC_RADIOMATCHTIME1, LNG_MEDIA_45MN },
		{ IDC_RADIOMATCHTIME2, LNG_MEDIA_60MN },
		{ IDC_RADIOMATCHTIME3, LNG_MEDIA_74MN },
		{ IDC_RADIOMATCHTIME4, LNG_MEDIA_80MN },
		{ IDC_RADIOMATCHTIME5, LNG_MEDIA_90MN },
		{ IDC_RADIOMATCHTIME6, LNG_MEDIA_120MN },
		{ IDC_RADIOMATCHTIME7, LNG_MEDIA_CUSTOM_MN },
		{ IDOK, LNG_BTN_OK },
		{ IDCANCEL, LNG_BTN_CANCEL }
	};
	
	for (int i = 0 ; i<NUMELEMENTS(lrs); i++)
		DlgSetText(m_hDlg, lrs[i].idRes, GS(lrs[i].idLNG) );

	SetWindowText(m_hDlg, GS(LNG_MEDIA_TITLE) );
}




// //////////////////////////////
// End part for CDlgMatchTime Dialog
// //////////////////////////////