#include "priv.h"

#include "resource.h"
#include "definition.h"
#include "Dlg.h"
#include "Util.h"
#include "Language.h"

// external declaration
extern INITSTRUCT gParam;
extern CLanguage    *lng;


/* ************************************************************************ */
BOOL CDlgOption::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		InitLanguage();
		LoadParam();
		return FALSE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDC_RADIO_DBLCLIC_PLAY:
		case IDC_RADIO_DBLCLIC_ENQUEUE:
		case IDC_RADIO_DBLCLIC_EDITTAG:
	        gParam.nDblClic = LOWORD(wParam) - IDC_RADIO_DBLCLIC_PLAY;
	        CheckRadioButton (m_hDlg, IDC_RADIO_DBLCLIC_PLAY, IDC_RADIO_DBLCLIC_EDITTAG, (int)wParam);
			return TRUE;

		case IDC_BUTTON_WEBSTYLE:
			{
				CDlgStyleHTML dlg;
				dlg.DoModal(IDD_DLGSTYLEHTML, m_hDlg);
			}
			return TRUE;
		case IDOK:
			if (SaveParam() == TRUE)
				EndDialog(m_hDlg, 0);
			return TRUE;

		case IDCANCEL:
			EndDialog(m_hDlg, 0);
			return TRUE;

		
		}
		
	}
	return FALSE;
}


/* ************************************************************** */
BOOL  CDlgOption::LoadParam()
{
	// Load options
	CheckRadioButton(m_hDlg, IDC_RADIO_EXPORTALLITEM, IDC_RADIO_EXPORTSELECTITEM, gParam.bExportAllItems == 0 ? IDC_RADIO_EXPORTALLITEM: IDC_RADIO_EXPORTSELECTITEM) ; 
	CheckRadioButton(m_hDlg, IDC_RADIO_FORMAT_TABLE, IDC_RADIO_FORMAT_LISTING, gParam.bExportHTML_Format == 0 ? IDC_RADIO_FORMAT_TABLE: IDC_RADIO_FORMAT_LISTING) ; 
	CheckDlgButton(m_hDlg, IDC_CHECK_LINKFILE, (UINT)(gParam.bExportHTML_Link == 1 ? BST_CHECKED : BST_UNCHECKED));  
	CheckDlgButton(m_hDlg, IDC_CHECK_BOTH_ID3, (UINT)(gParam.bExportBothID3 == 1 ? BST_CHECKED : BST_UNCHECKED));  
	CheckRadioButton(m_hDlg, IDC_RADIO_LOAD_EZPLAYLIST,  IDC_RADIO_LOAD_WINAMP, gParam.nOnStartup == 0 ? IDC_RADIO_LOAD_EZPLAYLIST: IDC_RADIO_LOAD_WINAMP); 
	CheckRadioButton(m_hDlg, IDC_RADIO_DBLCLIC_PLAY, IDC_RADIO_DBLCLIC_EDITTAG, (int)(gParam.nDblClic + IDC_RADIO_DBLCLIC_PLAY)) ; 
	
	return TRUE;
}


/* ************************************************************** */
BOOL  CDlgOption::SaveParam()
{
	// Save options
	gParam.bExportAllItems    = (IsDlgButtonChecked(m_hDlg, IDC_RADIO_EXPORTALLITEM) == BST_CHECKED ? 0 : 1);
	gParam.bExportHTML_Format = (IsDlgButtonChecked(m_hDlg, IDC_RADIO_FORMAT_TABLE) == BST_CHECKED ? 0 : 1);
	gParam.bExportHTML_Link   = (IsDlgButtonChecked(m_hDlg, IDC_CHECK_LINKFILE) == BST_CHECKED ? 1 : 0);
	gParam.bExportBothID3     = (IsDlgButtonChecked(m_hDlg, IDC_CHECK_BOTH_ID3) == BST_CHECKED ? 1 : 0);
	gParam.nOnStartup         = (IsDlgButtonChecked(m_hDlg, IDC_RADIO_LOAD_EZPLAYLIST) == BST_CHECKED ? 0 : 1);
	
	return TRUE;
}


// **********************************************
void CDlgOption::InitLanguage()
{
	LNGRESSTRUCT lrs[17] = 
	{
		{ R_OPT_FRAME_EXPORT, LNG_OPT_FRAME_EXPORT },
		{ IDC_RADIO_EXPORTALLITEM, LNG_OPT_ALL_ITEM },
		{ IDC_RADIO_EXPORTSELECTITEM, LNG_OPT_SELECTED_ITEM },
		{ R_OPT_FRAME_HTML, LNG_OPT_FRAME_HTML },
		{ IDC_RADIO_FORMAT_TABLE, LNG_OPT_TABLE_FORMAT },
		{ IDC_RADIO_FORMAT_LISTING, LNG_OPT_LISTING_FORMAT },
		{ IDC_CHECK_LINKFILE, LNG_OPT_ADD_HYPERLINK },
		{ IDC_CHECK_BOTH_ID3, LNG_OPT_BOTH_ID3V1ID3V2 },
		{ R_OPT_FRAME_STARTUP, LNG_OPT_FRAME_STARTUP },
		{ IDC_RADIO_LOAD_EZPLAYLIST, LNG_OPT_START_EZPLAYLIST },
		{ IDC_RADIO_LOAD_WINAMP, LNG_OPT_START_WINAMPPLAYLIST },
		{ R_OPT_FRAME_MOUSE, LNG_OPT_FRAME_MOUSE },
		{ IDC_RADIO_DBLCLIC_PLAY, LNG_OPT_DBLCLIC_PLAY },
		{ IDC_RADIO_DBLCLIC_ENQUEUE, LNG_OPT_DBLCLIC_ENQUEUE },
		{ IDC_RADIO_DBLCLIC_EDITTAG, LNG_OPT_DBLCLIC_EDIT_TAG },
		{ IDOK, LNG_BTN_OK },
		{ IDCANCEL, LNG_BTN_CANCEL }
	};
	
	for (int i = 0 ; i<NUMELEMENTS(lrs); i++)
		DlgSetText(m_hDlg, lrs[i].idRes, GS(lrs[i].idLNG) );
	
	SetWindowText(m_hDlg, GS(LNG_OPT_TITLE) );
}


// //////////////////////////////
// End part for DlgOption Dialog
// //////////////////////////////