#include "priv.h"

#include "resource.h"
#include "definition.h"
#include "Dlg.h"
#include "Util.h"
#include "Language.h"


// external declaration
extern INITSTRUCT gParam;
extern CLanguage    *lng;



/* ************************************************************************ */
BOOL CDlgOptionExplorer::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		InitLanguage();
		LoadParam();
		return FALSE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDOK:
			if (SaveParam() == TRUE)
				EndDialog(m_hDlg, (int)TRUE);
			return TRUE;

		case IDCANCEL:
			EndDialog(m_hDlg, 0);
			return TRUE;
		}
		
	}
	return FALSE;
}

// **********************************************
void CDlgOptionExplorer::InitLanguage()
{
	LNGRESSTRUCT lrs[7] = 
	{
		{ IDC_FRAME_OPTION_EXPLORER, LNG_OPTIONEXPLORER_FRAME },
		{ IDC_EXPLORER_OPTION1, LNG_ARTIST },
		{ IDC_EXPLORER_OPTION2, LNG_GENRE },
		{ IDC_EXPLORER_OPTION3, LNG_ID3TAG },
		{ IDC_EXPLORER_OPTION4, LNG_COMMENT } ,
		{ IDC_EXPLORER_OPTION5, LNG_MODE } ,
		{ IDC_EXPLORER_OPTION6, LNG_ALBUM } 
	};
	
	for (int i = 0 ; i<NUMELEMENTS(lrs); i++)
		DlgSetText(m_hDlg, lrs[i].idRes, GS(lrs[i].idLNG) );

	SetWindowText(m_hDlg, GS(LNG_OPTIONEXPLORER_TITLE) );

}




/* ************************************************************************ */
void CDlgOptionExplorer::LoadParam()
{
	for (int i = 0; i < 6; i++)
		CheckDlgButton(m_hDlg, IDC_EXPLORER_OPTION1+i,(gParam.nOptionExplorer & (1<<i))?BST_CHECKED:BST_UNCHECKED);
}


/* ************************************************************************ */
BOOL CDlgOptionExplorer::SaveParam()
{
	// Save options
	gParam.nOptionExplorer=0;

	for (int i = 0; i < 6; i++)
		if (IsDlgButtonChecked(m_hDlg,IDC_EXPLORER_OPTION1+i))
			gParam.nOptionExplorer |= 1<<i;

	if (gParam.nOptionExplorer ==0)
	{	MessageBox(m_hDlg, GS(LNG_MSG_SELECT_FIELD), GS(LNG_INFORMATION), MB_OK | MB_ICONINFORMATION);
		return FALSE;
	}

	return TRUE;
}




// //////////////////////////////////
// End part for CDlgOptionExplorer Dialog
// //////////////////////////////////