#include "priv.h"
#include "gen.h"
#include "resource.h"
#include "definition.h"
#include "Dlg.h"
#include "Util.h"
#include "Language.h"

// external declaration
extern INITSTRUCT gParam;
extern winampGeneralPurposePlugin plugin;
extern CLanguage    *lng;


/* ************************************************************************ */
BOOL CDlgStyleHTML::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		InitLanguage();
		LoadParam();
		return FALSE;

	case WM_DRAWITEM:
        doDrawBtnColor((LPDRAWITEMSTRUCT)lParam);
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDC_STYLE_COLORBUTTON1:
		case IDC_STYLE_COLORBUTTON2:
		case IDC_STYLE_COLORBUTTON3:
		case IDC_STYLE_COLORBUTTON4:
		case IDC_STYLE_COLORBUTTON5:
		case IDC_STYLE_COLORBUTTON6:
		case IDC_STYLE_COLORBUTTON7:
		case IDC_STYLE_COLORBUTTON8:
		case IDC_STYLE_COLORBUTTON9:
			doChooseColor(LOWORD(wParam)-IDC_STYLE_COLORBUTTON1);
			return TRUE;

		case IDC_STYLE_COLOREDIT1:		// color text
		case IDC_STYLE_COLOREDIT2:
		case IDC_STYLE_COLOREDIT3:
		case IDC_STYLE_COLOREDIT4:
		case IDC_STYLE_COLOREDIT5:	// background text
		case IDC_STYLE_COLOREDIT6:
		case IDC_STYLE_COLOREDIT7:
		case IDC_STYLE_COLOREDIT8:
		case IDC_STYLE_COLOREDIT9:	// background page
			if (HIWORD(wParam) == EN_UPDATE)
				doEditHexColor(LOWORD(wParam)-IDC_STYLE_COLOREDIT1);
			return TRUE;		
		
		case IDC_STYLE_CBOFONTNAME1:
		case IDC_STYLE_CBOFONTNAME2:
		case IDC_STYLE_CBOFONTNAME3:
		case IDC_STYLE_CBOFONTNAME4:
			if (HIWORD(wParam) == CBN_SELCHANGE )
			{	int i = LOWORD(wParam) - IDC_STYLE_CBOFONTNAME1;
				doSaveFontName(i);	
			}
			return TRUE;

		case IDC_STYLE_CBOFONTSTYLE1:
		case IDC_STYLE_CBOFONTSTYLE2:
		case IDC_STYLE_CBOFONTSTYLE3:
		case IDC_STYLE_CBOFONTSTYLE4:
			if (HIWORD(wParam) == CBN_SELCHANGE )
			{	int i = LOWORD(wParam) - IDC_STYLE_CBOFONTSTYLE1;
				doSaveFontStyle(i);	
			}
			return TRUE;

		case IDC_STYLE_CBOFONTSIZE1:
		case IDC_STYLE_CBOFONTSIZE2:
		case IDC_STYLE_CBOFONTSIZE3:
		case IDC_STYLE_CBOFONTSIZE4:
			if (HIWORD(wParam) == CBN_SELCHANGE )
			{	int i = LOWORD(wParam) - IDC_STYLE_CBOFONTSIZE1;
				doSaveFontSize(i);	
			}
			return TRUE;

		case IDC_STYLE_CBO:
			doChangeStyle();
			return TRUE;

		case IDOK:
			if (SaveParam() == TRUE)
				EndDialog(m_hDlg, 0);
			return TRUE;

		case IDCANCEL:
			EndDialog(m_hDlg, 0);
			return TRUE;
		}
		
	}
	return FALSE;
}


/* ************************************************************** */
BOOL  CDlgStyleHTML::LoadParam()
{
	int i;
	TCHAR *szStyleHTML[MAX_TEMPLATE] = {
		_T("Paris"), 
		_T("London"), 
		_T("New-York"), 
		_T("Cairo"), 
		_T("Tokyo"),
		_T("Athena"),
		_T("Toronto"),
		_T("Geneva")
	};
	TCHAR *szFontStyle[]= { 
		GS(LNG_HTML_FONT_REGULAR), 
		GS(LNG_HTML_FONT_BOLD), 
		GS(LNG_HTML_FONT_ITALIC), 
		GS(LNG_HTML_FONT_BOLD_ITALIC)};
	
	m_bIsLoading = TRUE;

	// Init control Combobox
	for  (i = 0; i<NUMELEMENTS(szStyleHTML); i++)
		SendDlgItemMessage(m_hDlg, IDC_STYLE_CBO, CB_ADDSTRING, 0, (LPARAM)szStyleHTML[i]);	
	
	
	for (int k=0; k<MAX_CSS; k++)
	{
		HWND hCboFontName  = GetDlgItem(m_hDlg, IDC_STYLE_CBOFONTNAME1  + k); 
		HWND hCboFontStyle = GetDlgItem(m_hDlg, IDC_STYLE_CBOFONTSTYLE1 + k);
		HWND hCboFontSize  = GetDlgItem(m_hDlg, IDC_STYLE_CBOFONTSIZE1  + k);

		SendMessage(hCboFontName,  CB_RESETCONTENT, 0, 0);
		SendMessage(hCboFontStyle, CB_RESETCONTENT, 0, 0);
		SendMessage(hCboFontSize,  CB_RESETCONTENT, 0, 0);

		for  (i = 0; i<NUMELEMENTS(CSSFontName); i++)
			SendMessage(hCboFontName, CB_ADDSTRING, 0, (LPARAM)CSSFontName[i]);	
		
		for  (i = 0; i<NUMELEMENTS(CSSFontSize); i++)
			SendMessage(hCboFontSize, CB_ADDSTRING, 0, (LPARAM)CSSFontSize[i]);	

		for  (i = 0; i<NUMELEMENTS(szFontStyle); i++)
			SendMessage(hCboFontStyle, CB_ADDSTRING, 0, (LPARAM)szFontStyle[i]);	
		
	}

	
	m_pTemplate = &gParam.Template[gParam.nCurrentTemplate];
	
	SendDlgItemMessage(m_hDlg, IDC_STYLE_CBO,  CB_SETCURSEL, gParam.nCurrentTemplate, 0);
	doChangeStyle();

	m_bIsLoading = FALSE;
	return TRUE;
}


/* ************************************************************** */
BOOL  CDlgStyleHTML::SaveParam()
{
	// Save options
	gParam.nCurrentTemplate = SendDlgItemMessage(m_hDlg, IDC_STYLE_CBO,  CB_GETCURSEL, 0, 0);
	

	return TRUE;
}

/* ************************************************************** */
void CDlgStyleHTML::doChangeStyle()
{
	int i;

	int nTemplate = SendDlgItemMessage(m_hDlg, IDC_STYLE_CBO,  CB_GETCURSEL, 0, 0);
	
	m_pTemplate = &gParam.Template[nTemplate];


	// Update Color en fonction du Param StyleHtml
	for (i=0; i< 9; i++)
	{
		SendDlgItemMessage( m_hDlg, IDC_STYLE_COLOREDIT1 + i, EM_SETLIMITTEXT , 6L, 0L);
		InvalidateRect(GetDlgItem(m_hDlg,IDC_STYLE_COLORBUTTON1 + i), NULL, TRUE);
	}
	

	for (i=0; i<MAX_CSS; i++)
	{
		SendDlgItemMessage(m_hDlg, IDC_STYLE_CBOFONTNAME1  + i, CB_SETCURSEL, m_pTemplate->css[i].nFontName,  0);
		SendDlgItemMessage(m_hDlg, IDC_STYLE_CBOFONTSTYLE1 + i, CB_SETCURSEL, m_pTemplate->css[i].nFontStyle, 0);
		SendDlgItemMessage(m_hDlg, IDC_STYLE_CBOFONTSIZE1  + i, CB_SETCURSEL, m_pTemplate->css[i].nFontSize,  0);
	}
	

}

/****************************************************************************
 * FUNCTION:  doChooseColor
 * Initialise la boite de dialogue selection de couleur
 *****************************************************************************/
void CDlgStyleHTML::doChooseColor(int nButton)
{
	CHOOSECOLOR cc;
	COLORREF rgbOld; 
	static COLORREF rgDefault_columnors[16];

	rgbOld = GetColorButton(nButton);


	cc.lStructSize = sizeof(CHOOSECOLOR); 
    cc.hwndOwner = m_hDlg; 
    cc.hInstance = (HWND)plugin.hDllInstance; 
    cc.rgbResult = rgbOld; 
    cc.lpCustColors = rgDefault_columnors; 
    cc.Flags = CC_RGBINIT; 
    cc.lCustData = 0; 
    cc.lpfnHook = NULL; 
    cc.lpTemplateName = NULL; 
	
	if (ChooseColor(&cc) == 0)
		return;

	SetColorButton(nButton, cc.rgbResult);
	InvalidateRect(GetDlgItem(m_hDlg,IDC_STYLE_COLORBUTTON1 + nButton), NULL, TRUE);
}



/* ************************************************************************** */
COLORREF CDlgStyleHTML::GetColorButton(int i)
{                                                    
	int x = i % 2;
	int y = i / 2;

	if ( i== 9 )
		// Hyperlink color
		return(m_pTemplate->cLinkColor);

	if (x == 1)
		// Background color CSS
		return(m_pTemplate->css[y].cColorBack);
	else
		// Text color CSS
		return(m_pTemplate->css[y].cColor);
	
	
}

/* ************************************************************************** */
void CDlgStyleHTML::SetColorButton(int i, COLORREF cColorNew)
{                                                    
	int x = i % 2;
	int y = i / 2;

	if ( i== 9 )
	{
		// Hyperlink page
		m_pTemplate->cLinkColor = cColorNew;
		return;
	}

	if (x == 1)
		// Background color CSS
		m_pTemplate->css[y].cColorBack = cColorNew;
	else
		// Text color CSS
		m_pTemplate->css[y].cColor = cColorNew;
	

}

/* ***************************************************************************
 *  doDrawBtnColor draw owner buttons
 *
 *  Input parameters:
 *    lpdis = Pointer to DRAWITEMSTRUCT structure
 *
 *  Returns:
 *    Nothing
 ****************************************************************************/
void CDlgStyleHTML::doDrawBtnColor (LPDRAWITEMSTRUCT lpdis)
{                                                    
    HDC hDC;
    RECT rect;
    HBRUSH hBrush, hOldBrush;
	COLORREF crColor;


    hDC = lpdis->hDC;
    CopyRect (&rect, &(lpdis->rcItem));    

	// Draw Button select color
	switch (lpdis->CtlID)
	{
	case IDC_STYLE_COLORBUTTON1:
	case IDC_STYLE_COLORBUTTON2:
	case IDC_STYLE_COLORBUTTON3:
	case IDC_STYLE_COLORBUTTON4:
	case IDC_STYLE_COLORBUTTON5:
	case IDC_STYLE_COLORBUTTON6:
	case IDC_STYLE_COLORBUTTON7:
	case IDC_STYLE_COLORBUTTON8:
	case IDC_STYLE_COLORBUTTON9:

		// Draw button face 3D
		DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);

		switch (lpdis->itemAction) 
		{	case ODA_DRAWENTIRE:  
			case ODA_FOCUS:
				{	rect.left   += 1;
					rect.right  -= 3;
					rect.top    += 1;
					rect.bottom -= 3;
				}
				break;
			case ODA_SELECT:
				break;
		}                                
        
		// Affiche la couleur selectionne sur le bouton
		int nButton = lpdis->CtlID - IDC_STYLE_COLORBUTTON1;


		crColor = GetColorButton(nButton);
		
		hBrush = (HBRUSH)CreateSolidBrush(crColor);
		hOldBrush = (HBRUSH)SelectObject(hDC, hBrush);
		FillRect(hDC, &rect,(HBRUSH)hBrush);
		SelectObject(hDC, (HBRUSH)DeleteObject(hBrush));
		
		
		// Affiche le code RGB2HEX zone de texte
		TCHAR szHex[30];

		_stprintf(szHex, _T("%02X%02X%02X"), 
			GetRValue(crColor), 
			GetGValue(crColor),
			GetBValue(crColor));
			
		m_bIsLoading = TRUE;
		SetWindowText(GetDlgItem(m_hDlg, IDC_STYLE_COLOREDIT1 + nButton), szHex);
		m_bIsLoading = FALSE;
	}	
	


}         

/* *********************************************************************** */
void CDlgStyleHTML::doEditHexColor(int nEditColor)
{
	TCHAR szHex[30];
	HWND hEditColor = GetDlgItem(m_hDlg, IDC_STYLE_COLOREDIT1 + nEditColor);
	int nLen = GetWindowTextLength(hEditColor);
	int i;

	if (m_bIsLoading == TRUE)	return;
	if (nLen <6)				return;

	GetWindowText(hEditColor, (LPTSTR)szHex, nLen+1);

	for(i = 0; i < nLen; i++ )
	{
		if( !_istxdigit(szHex[i]))
		{
			MessageBox(m_hDlg, GS(LNG_HTML_MSG_HEXANOTVALID), GS(LNG_ERROR), MB_OK|MB_ICONERROR);	
			return;
		}
	}


	COLORREF crColorEdit;
	i = _stscanf(szHex, _T("%6lx"), &crColorEdit);
  
	if(i <= 0)
	{	MessageBox(m_hDlg, GS(LNG_HTML_MSG_ERRHEXA), GS(LNG_ERROR), MB_OK|MB_ICONERROR);	
		return;
	}		

	int r = (int)(crColorEdit & 0xFF0000) >> 16;    crColorEdit <<= 8;
	int g = (int)(crColorEdit & 0xFF0000) >> 16;    crColorEdit <<= 8;
	int b = (int)(crColorEdit & 0xFF0000) >> 16;
    

	// update button with the new color
	SetColorButton(nEditColor, RGB(r,g,b));
	InvalidateRect(GetDlgItem(m_hDlg,IDC_STYLE_COLORBUTTON1 + nEditColor), NULL, TRUE);
}


/* *********************************************************************** */
void CDlgStyleHTML::doSaveFontName(int nIndex)
{
	if (m_bIsLoading == TRUE) return;
	m_pTemplate->css[nIndex].nFontName = SendDlgItemMessage(m_hDlg, IDC_STYLE_CBOFONTNAME1 + nIndex,CB_GETCURSEL,0,0);				
}

/* *********************************************************************** */
void CDlgStyleHTML::doSaveFontStyle(int nIndex)
{
	if (m_bIsLoading == TRUE) return;
	m_pTemplate->css[nIndex].nFontStyle = SendDlgItemMessage(m_hDlg, IDC_STYLE_CBOFONTSTYLE1 + nIndex,CB_GETCURSEL, 0,0);				
}

/* *********************************************************************** */
void CDlgStyleHTML::doSaveFontSize(int nIndex)
{
	if (m_bIsLoading == TRUE) return;
	m_pTemplate->css[nIndex].nFontSize = SendDlgItemMessage(m_hDlg, IDC_STYLE_CBOFONTSIZE1 + nIndex,CB_GETCURSEL,0,0);				
}

// **********************************************
void CDlgStyleHTML::InitLanguage()
{
	LNGRESSTRUCT lrs[14] = 
	{
		{ R_HTML_FRAME_CSS, LNG_HTML_FRAME_CSS },
		{ R_HTML_TEMPLATE, LNG_HTML_TEMPLATE },
		{ R_HTML_COLOR_TEXT, LNG_HTML_COLOR_TEXT },
		{ R_HTML_COLOR_BACKGROUND, LNG_HTML_COLOR_BACKGROUND },
		{ R_HTML_FONT_NAME, LNG_HTML_FONT_NAME },
		{ R_HTML_FONT_STYLE, LNG_HTML_FONT_STYLE },
		{ R_HTML_FONT_SIZE, LNG_HTML_FONT_SIZE },
		{ R_HTML_BODY_TEXT, LNG_HTML_BODY_TEXT },
		{ R_HTML_TITLE_PAGE, LNG_HTML_TITLE_PAGE },
		{ R_HTML_HEADER_COL, LNG_HTML_HEADER_COL },
		{ R_HTML_TEXT_COLUMNS, LNG_HTML_TEXT_COLUMNS },
		{ R_HTML_HYPERLINK_COLOR, LNG_HTML_HYPERLINK_COLOR },
		{ IDOK, LNG_BTN_OK },
		{ IDCANCEL, LNG_BTN_CANCEL }
	};
	
	for (int i = 0 ; i<NUMELEMENTS(lrs); i++)
		DlgSetText(m_hDlg, lrs[i].idRes, GS(lrs[i].idLNG) );
	
	SetWindowText(m_hDlg, GS(LNG_HTML_TITLE) );
}

// /////////////////////////////////
// End part for CDlgStyleHTML Dialog
// /////////////////////////////////