#include "priv.h"
#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "definition.h"
#include "Dlg.h"
#include "util.h"
#include "Language.h"
#include "systray.h"


// external declaration
extern winampGeneralPurposePlugin plugin;
extern int systray_enabled;
extern CLanguage    *lng;



/* ************************************************************** */
BOOL CDlgSysTray::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			LNGRESSTRUCT lrs[12] = 
			{
				{ IDC_CFG_FRAME, LNG_CFG_FRAME_CTRL },
				{ IDC_PREV8, LNG_CFG_GROUP_IN_MENU },
				{ IDC_PREV1, LNG_TIPS_EXTPLAYLIST },
				{ IDC_PREV2, LNG_TIPS_PREVIOUSTRACK },
				{ IDC_PREV3, LNG_TIPS_PLAYPAUSE },
				{ IDC_PREV4, LNG_TIPS_STOP },
				{ IDC_PREV5, LNG_TIPS_NEXTTRACK },
				{ IDC_PREV6, LNG_TIPS_LOADFILE },
				{ IDC_PREV7, LNG_TIPS_VOLUME },
				{ IDOK,      LNG_BTN_OK },
				{ IDCANCEL,  LNG_BTN_CANCEL },
				{ IDC_APPLY, LNG_BTN_APPLY }
			};
				
			for (int i = 0 ; i<NUMELEMENTS(lrs); i++)
				DlgSetText(m_hDlg, lrs[i].idRes, GS(lrs[i].idLNG) );
			
			SetWindowText(m_hDlg, GS(LNG_CFG_TITLE) );

			for ( i = 0; i < NUM_ICONSYSTRAY; i++)
				CheckDlgButton(m_hDlg,IDC_PREV1+i,(systray_enabled & (1<<i))?BST_CHECKED:BST_UNCHECKED);

			if (IsDlgButtonChecked(m_hDlg,IDC_PREV8) == BST_CHECKED)
			{	for (i = 0; i < NUM_ICONSYSTRAY-1; i++)
				{	CheckDlgButton(m_hDlg,IDC_PREV1+i, BST_UNCHECKED);
					EnableWindow(GetDlgItem(m_hDlg,IDC_PREV1+i), FALSE);
				}
			}
		}
		return FALSE;

	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(m_hDlg, &ps);
			
			for (int i = 0; i < NUM_ICONSYSTRAY-1; i++)
			{
				RECT rc;
				POINT pt;
				HWND hwndChk = GetDlgItem(m_hDlg,IDC_PREV1+i);
				
				GetWindowRect(hwndChk, &rc);
				HICON hIcon = (HICON)LoadImage(plugin.hDllInstance, MAKEINTRESOURCE(IDI_ICONSMALL1+i),
					   IMAGE_ICON, GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), 0);

				pt.x = rc.left - 25;
				pt.y = rc.top + 2;
				ScreenToClient(m_hDlg, &pt);

				if(hIcon)	
					DrawIconEx(hDC, pt.x, pt.y, hIcon, 0, 0, 0, NULL, DI_NORMAL );
			}
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
			case IDC_PREV8:		// checkbox Group in systray menu
				if (HIWORD(wParam) == BN_CLICKED)	
				{
					BOOL bEnable = (IsDlgButtonChecked(m_hDlg,IDC_PREV8) == BST_UNCHECKED);
					for (int i = 0; i < NUM_ICONSYSTRAY-1; i++)
					{
						CheckDlgButton(m_hDlg,IDC_PREV1+i, (bEnable ? BST_CHECKED:BST_UNCHECKED));
						EnableWindow(GetDlgItem(m_hDlg,IDC_PREV1+i), bEnable);
					}
				}
				return TRUE;
		
			case IDC_APPLY:
			case IDOK:
				systray_enabled=0;
				{
					for (int i = 0; i < NUM_ICONSYSTRAY; i++)
						if (IsDlgButtonChecked(m_hDlg,IDC_PREV1+i))
							systray_enabled |= 1<<i;
				}
				SysTray_Icons();

			case IDCANCEL:
				if (LOWORD(wParam) != IDC_APPLY) 
					EndDialog(m_hDlg,0);
				return FALSE;
		}
	}
	return FALSE;
}




 
// //////////////////////////////
// End part for DlgSysTray Dialog
// //////////////////////////////
