/* 
 *  language.h
 *
 *	Copyright (C) BOYER Jean-louis - December 2001 - boyerjl@club-internet.Fr
 *
 *  This file is part of EZPlaylist, a free plugin for WinAMP
 *  manage an extended Playlist, read/write ID3 Tag...
 *	
 *  EZPlaylist is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  EZPlaylist is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#if !defined(AFX_LANGUAGE_H__205B0701_EB94_11D3_816D_00000100CF13__INCLUDED_)
#define AFX_LANGUAGE_H__205B0701_EB94_11D3_816D_00000100CF13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include <TCHAR.h>
#define MAX_LANGUAGES 32
#define MAX_STRINGS   4096

#define GS(x) ( _tcscmp(lng->GetString(x),_T("")) ? lng->GetString(x) : NULL )


// Class 'CLanguage'
class CLanguage  
{
private:
	int  m_nSelectedLanguage;
	int  m_nCountLanguage;

public:
	CLanguage();
	virtual ~CLanguage();
	int Start(TCHAR* szSetLang);
	int ReadLanguage();
	TCHAR* GetString(int strID);
	int SetLanguageID( int nNewlang );
	int GetLanguageID();
	TCHAR* GetLanguage();
	TCHAR* GetLanguage(int index);
	int GetNumberLang();
	
private:	
	void DeleteLang();
	void LoadDefaultStrings();
};




///////////////////////////////////////////////////////////////////////
//   LANGUAGE DEFAULTS
///////////////////////////////////////////////////////////////////////
 
#define LNG_LANGUAGE_PACK 0
#define LNG_APPNAME 1
#define LNG_TIPS_EXTPLAYLIST 2
#define LNG_TIPS_PREVIOUSTRACK 3
#define LNG_TIPS_PLAYPAUSE 4
#define LNG_TIPS_STOP 5
#define LNG_TIPS_NEXTTRACK 6
#define LNG_TIPS_LOADFILE 7
#define LNG_TIPS_VOLUME 8
#define LNG_TIPS_NOTAG 9
#define LNG_TIPS_EZMENU 10
#define LNG_BTN_OK 11
#define LNG_BTN_CANCEL 12
#define LNG_BTN_APPLY 13
#define LNG_BTN_UPDATE 14
#define LNG_BTN_FILE 15
#define LNG_BTN_GO 16
#define LNG_BTN_TRANSFER 17
#define LNG_BTN_UP 18
#define LNG_BTN_DOWN 19
#define LNG_QUESTION 20
#define LNG_ERROR 21
#define LNG_INFORMATION 22
#define LNG_FAILED 23
#define LNG_SUCCESS 24
#define LNG_MSG_SELECT_COLUMN 25
#define LNG_MSG_SELECT_FILE 26
#define LNG_MSG_CHOOSELOG 27
#define LNG_MSG_ERRLOG 28
#define LNG_LOG_FILE 29
#define LNG_STATUS_WORKING 30
#define LNG_TITLE_ID3TOOLS 31
#define LNG_LOG_COPYID3V1_ID3V2 32
#define LNG_LOG_COPYID3V2_ID3V1 33
#define LNG_LOG_REMOVEID3V1 34
#define LNG_LOG_REMOVEID3V2 35
#define LNG_LOG_REMOVEID3V1_ID3V2 36
#define LNG_RESULT_COPYID3V1_ID3V2 37
#define LNG_RESULT_COPYID3V2_ID3V1 38
#define LNG_RESULT_REMOVEID3V1 39
#define LNG_RESULT_REMOVEID3V2 40
#define LNG_RESULT_REMOVEID3V1_ID3V2 41
#define LNG_MSG_EDITTAG_INFO 42
#define LNG_MSG_EDITTAG_ERR 43
#define LNG_MSG_EDITTAG_CONFIRM 44
#define LNG_MSG_EDITTAG_SELECTFILE 45
#define LNG_MSG_EDITTAG_CANTREAD 46
#define LNG_MSG_EDITTAG_CANTWRITE 47
#define LNG_MSG_EDITTAG_STATUSUPDATING 48
#define LNG_MSG_MASSTAG_INFO 49
#define LNG_MSG_MASSTAG_ERR 50
#define LNG_MSG_MASSTAG_LOG 51
#define LNG_MSG_MASSTAG_RESULT 52
#define LNG_MSG_RENAMEFILE_INFO 53
#define LNG_MSG_RENAMEFILE_ERR 54
#define LNG_MSG_RENAMEFILE_LOG 55
#define LNG_MSG_RENAMEFILE_RESULT 56
#define LNG_UNKOWNARTIST 57
#define LNG_UNTITLED 58
#define LNG_UNKOWNALBUM 59
#define LNG_UNKOWNGENRE 60
#define LNG_MSG_WRITETAG_INFO 61
#define LNG_MSG_WRITETAG_ERR 62
#define LNG_MSG_WRITETAG_LOG 63
#define LNG_MSG_WRITETAG_RESULT 64
#define LNG_MSG_ORGANIZEFILE_LOG  65
#define LNG_MSG_ORGANIZE_RESULT 66
#define LNG_MSG_CHOOSEPATHDEST 67
#define LNG_LOG_ORGANIZE_FILE 68
#define LNG_MSG_TIME_MUSTBENOTNULL 69
#define LNG_MSG_CONFIRM_MASS 70
#define LNG_MSG_CONFIRM_RENAME 71
#define LNG_MSG_CONFIRM_WRITETAGFROMFILENAME 72
#define LNG_MSG_CONFIRM_COPYID3V1TOID3V2 73
#define LNG_MSG_CONFIRM_COPYID3V2TOID3V1 74
#define LNG_MSG_CONFIRM_REMOVEID3V1 75
#define LNG_MSG_CONFIRM_REMOVEID3V2 76
#define LNG_MSG_CONFIRM_REMOVEID3V1ID3V2 77
#define LNG_MSG_CONFIRM_ORGANIZE 78
#define LNG_MOREFILES 79
#define LNG_PROCEEDTHEM 80
#define LNG_SEPARATORNOTNULL 81
#define LNG_CHECKID3 82
#define LNG_COLUMNFILTER_GENRE 83
#define LNG_COLUMNFILTER_COUNT 84
#define LNG_RESETDEFAULT 85
#define LNG_ARTIST 86
#define LNG_TITLE 87
#define LNG_ALBUM 88
#define LNG_YEAR 89
#define LNG_COMMENT 90
#define LNG_GENRE 91
#define LNG_TRACK 92
#define LNG_MODE 93
#define LNG_BITRATE 94
#define LNG_FREQ 95
#define LNG_LAYER 96
#define LNG_TIME 97
#define LNG_SIZE 98
#define LNG_FILENAME 99
#define LNG_ID3TAG 100
#define LNG_BPM 101
#define LNG_BPM_DESCRIPTION 102
#define LNG_INIT_KEY 103
#define LNG_SUBTITLE 104
#define LNG_REMIXED 105
#define LNG_COMPOSER 106
#define LNG_HTML_DATE 107
#define LNG_FILTEROPENDIALOG_LOG 108
#define LNG_FILTEROPENDIALOG_IMPORT 109
#define LNG_FILTEROPENDIALOG_EXPORT 110
#define LNG_FILTERADDFILE 111
#define LNG_IMPORTPLAYLIST 112
#define LNG_EXPORTPLAYLIST 113
#define LNG_STATUS_TOTALFILE 114
#define LNG_STATUS_TOTALSIZE 115
#define LNG_STATUS_TOTALSIZE_FLOAT 116
#define LNG_STATUS_AVGSIZE_FLOAT 117
#define LNG_STATUS_AVGLENGTH 118
#define LNG_STATUS_SELLENGTH 119
#define LNG_STATUS_TOTALLENGTH 120
#define LNG_PROPERTY_ID3TAG 121
#define LNG_SHORTTIME_FRMT 122
#define LNG_FULLTIME_FRMT 123
#define LNG_CLIPBORADMEMERROR 124
#define LNG_NOTHING 125
#define LNG_VOLUME_VALUE 126
#define LNG_ERR_FILEPLAYLIST 127
#define LNG_ERR_BADFILE 128
#define LNG_ERR_CORRUPTFILE 129
#define LNG_ERR_BADFILEPLS 130
#define LNG_ADDFILE_TITLE 131
#define LNG_ADDFILE_TOOMANYFILE 132
#define LNG_ADDFILE_ERROR 133
#define LNG_SHBROWSEFOLDER_CHECKBOX 134
#define LNG_TITLEFILTER 135
#define LNG_ALLFILTER 136
#define LNG_TITLE_INFOPLAYLIST 137
#define LNG_ERROR_REMOVEFILE 138
#define LNG_CONFIRM_REMOVEFILE 139
#define LNG_MENU_FILE 140
#define LNG_MENU_NEW 141
#define LNG_MENU_OPEN 142
#define LNG_MENU_SAVE 143
#define LNG_MENU_SAVE_AS 144
#define LNG_MENU_RELOAD_WINAMP 145
#define LNG_MENU_ADD 146
#define LNG_MENU_ADD_FILE 147
#define LNG_MENU_ADD_DIRECTORY 148
#define LNG_MENU_INSERT_EZ3        149
#define LNG_MENU_IMPORT 150
#define LNG_MENU_EXPORT 151
#define LNG_MENU_PROPERTY_PLAYLIST 152
#define LNG_MENU_PROPERTY_VOLUME 153
#define LNG_MENU_QUIT 154
#define LNG_MENU_OPTIONS 155
#define LNG_MENU_OPT_COLUMN 156
#define LNG_MENU_OPT_OPTION 157
#define LNG_MENU_OPT_CONFIGURE 158
#define LNG_MENU_OPT_HTMLCSS 159
#define LNG_MENU_OPT_RESET_DEFAULT 160
#define LNG_MENU_OPT_FILTER 161
#define LNG_MENU_OPT_MEDIA_WIZARD 162
#define LNG_MENU_OPT_VIEW 163
#define LNG_MENU_OPT_EXPLORER 164
#define LNG_MENU_OPT_EXPLORER_OPTION 165
#define LNG_MENU_OPT_LANGUAGE 166
#define LNG_MENU_ID3TAG 167
#define LNG_MENU_ID3TAG_EDIT 168
#define LNG_MENU_ID3TAG_MASS 169
#define LNG_MENU_ID3TAG_RENAME 170
#define LNG_MENU_ID3TAG_WRITE 171
#define LNG_MENU_ID3TAG_CONVERT 172
#define LNG_MENU_ID3TAG_ORGANIZE 173
#define LNG_MENU_ABOUT 174
#define LNG_MENU_SEARCH_ARTIST 175
#define LNG_MENU_SEARCH_TITLE 176
#define LNG_MENU_SEARCH_ALBUM 177
#define LNG_MENU_SEARCH_COMMENT 178
#define LNG_MENU_SEARCH_FILENAME 179
#define LNG_MENU_SEARCH_SELECTALL 180
#define LNG_MENU_SEARCH_SELECTNONE 181
#define LNG_MENU_SEARCH_MATCHCASEMODE 182
#define LNG_MENU_CAPITALIZE_UNCHANGED 183
#define LNG_MENU_CAPITALIZE_ALLLOWERCASE 184
#define LNG_MENU_CAPITALIZE_ALLUPPERCASE 185
#define LNG_MENU_CAPITALIZE_FIRSTLETTEROFSECTIONUPPERCASE 186
#define LNG_MENU_CAPITALIZE_FIRSTLETTEROFEACHWORDUPPERCASE 187
#define LNG_MENU_CONVERT_NO 188
#define LNG_MENU_CONVERT_UNDERSCORE_TO_SPACE 189
#define LNG_MENU_CONVERT_SPACE_TO_UNDERSCORE 190
#define LNG_MENU_SWAPID3_TITLE_ARTIST 191
#define LNG_MENU_SWAPID3_TITLE_ALBUM 192
#define LNG_MENU_SWAPID3_ARTIST_TITLE 193
#define LNG_MENU_SWAPID3_ARTIST_ALBUM 194
#define LNG_MENU_SWAPID3_ALBUM_TITLE 195
#define LNG_MENU_SWAPID3_ALBUM_ARTIST 196
#define LNG_MENU_PLAYLIST_PLAY 197
#define LNG_MENU_PLAYLIST_PLAYALL 198
#define LNG_MENU_PLAYLIST_EDITTAG 199
#define LNG_MENU_PLAYLIST_ENQUEUE 200
#define LNG_MENU_PLAYLIST_ENQUEUEALL 201
#define LNG_MENU_PLAYLIST_CLEARCURRENTPLAYLIST 202
#define LNG_MENU_PLAYLIST_SHOWHIDEPLAYLIST 203
#define LNG_MENU_PLAYLIST_SELECTALL 204
#define LNG_MENU_PLAYLIST_SELECTNONE 205
#define LNG_MENU_PLAYLIST_SELECTTOGGLE 206
#define LNG_MENU_PLAYLIST_SELECT_WITHSAME 207
#define LNG_MENU_PLAYLIST_SELECTALLDEADFILES 208
#define LNG_MENU_PLAYLIST_SELECTCROP 209
#define LNG_MENU_PLAYLIST_DEL 210
#define LNG_MENU_PLAYLIST_REMOVEFILE 211
#define LNG_MENU_PLAYLIST_SHOWDUPLICATE 212
#define LNG_MENU_PLAYLIST_PROPERTY 213
#define LNG_COL_TITLE 214
#define LNG_COL_VIEWINFO_FROM 215
#define LNG_COL_SHOW_NUMBER 216
#define LNG_COL_SHOW_GRID 217
#define LNG_COL_FRAME_SELECTFIELDS 218
#define LNG_COL_AVAILABLE_FIELDS 219
#define LNG_COL_SELECTED_FIELDS 220
#define LNG_COL_BTN_ADD 221
#define LNG_COL_BTN_ADD_ALL 222
#define LNG_COL_BTN_REMOVE 223
#define LNG_COL_BTN_REMOVE_ALL 224
#define LNG_MSG_SELECT_FIELD 225
#define LNG_MSG_ERR_BAD_NUMBER 226
#define LNG_MSG_ERR_BAD_RANGE_TIME 227
#define LNG_MSG_ERR_BAD_RANGE_FILESIZE 228
#define LNG_OPT_TITLE 229
#define LNG_OPT_FRAME_EXPORT 230
#define LNG_OPT_ALL_ITEM 231
#define LNG_OPT_SELECTED_ITEM 232
#define LNG_OPT_FRAME_HTML 233
#define LNG_OPT_TABLE_FORMAT 234
#define LNG_OPT_LISTING_FORMAT 235
#define LNG_OPT_ADD_HYPERLINK 236
#define LNG_OPT_BOTH_ID3V1ID3V2 237
#define LNG_OPT_FRAME_STARTUP 238
#define LNG_OPT_START_EZPLAYLIST 239
#define LNG_OPT_START_WINAMPPLAYLIST 240
#define LNG_OPT_FRAME_MOUSE 241
#define LNG_OPT_DBLCLIC_PLAY 242
#define LNG_OPT_DBLCLIC_ENQUEUE 243
#define LNG_OPT_DBLCLIC_EDIT_TAG 244
#define LNG_DUPLI_TITLE 245
#define LNG_DUPLI_FRAME 246
#define LNG_DUPLI_DIFF_LENGTH 247
#define LNG_DUPLI_DIFF_SIZE 248
#define LNG_CFG_TITLE 249
#define LNG_CFG_FRAME_CTRL 250
#define LNG_CFG_GROUP_IN_MENU 251
#define LNG_HTML_TITLE 252
#define LNG_HTML_FONT_REGULAR 253
#define LNG_HTML_FONT_BOLD 254
#define LNG_HTML_FONT_ITALIC 255
#define LNG_HTML_FONT_BOLD_ITALIC 256
#define LNG_HTML_MSG_HEXANOTVALID 257
#define LNG_HTML_MSG_ERRHEXA 258
#define LNG_HTML_FRAME_CSS 259
#define LNG_HTML_TEMPLATE 260
#define LNG_HTML_COLOR_TEXT 261
#define LNG_HTML_COLOR_BACKGROUND 262
#define LNG_HTML_FONT_NAME 263
#define LNG_HTML_FONT_STYLE 264
#define LNG_HTML_FONT_SIZE 265
#define LNG_HTML_BODY_TEXT 266
#define LNG_HTML_TITLE_PAGE 267
#define LNG_HTML_HEADER_COL 268
#define LNG_HTML_TEXT_COLUMNS 269
#define LNG_HTML_HYPERLINK_COLOR 270
#define LNG_RESET_TITLE 271
#define LNG_RESET_DESCRIPTION 272
#define LNG_RESET_FRAME_CATEGORIE 273
#define LNG_RESET_HTML 274
#define LNG_RESET_VIEW_COLUMN 275
#define LNG_RESET_ID3TOOLS 276
#define LNG_RESET_OPTION 277
#define LNG_ABOUT_TITLE 278
#define LNG_ABOUT_BTN_HELP 279
#define LNG_ABOUT_BTN_ABOUT 280
#define LNG_MEDIA_TITLE 281
#define LNG_MEDIA_FRAME 282
#define LNG_MEDIA_45MN 283
#define LNG_MEDIA_60MN 284
#define LNG_MEDIA_74MN 285
#define LNG_MEDIA_80MN 286
#define LNG_MEDIA_90MN 287
#define LNG_MEDIA_120MN 288
#define LNG_MEDIA_CUSTOM_MN 289
#define LNG_DLGID3TAG_TITLE 290
#define LNG_PAGE_MASSTAG_TITLE 291
#define LNG_PAGE_RENAMEFILE_TITLE 292
#define LNG_PAGE_WRITETAG_TITLE 293
#define LNG_PAGE_CONVERSIONREMOVE_TITLE 294
#define LNG_PAGE_ORGANIZE_TITLE 295
#define LNG_PAGE_EDITTAG_TITLE 296
#define LNG_PAGE_EDITTAG_MP3INFO1 297
#define LNG_PAGE_EDITTAG_MP3INFO2 298
#define LNG_ARTIST_SHORTCUT 299
#define LNG_TITLE_SHORTCUT 300
#define LNG_ALBUM_SHORTCUT 301
#define LNG_YEAR_SHORTCUT 302
#define LNG_COMMENT_SHORTCUT 303
#define LNG_GENRE_SHORTCUT 304
#define LNG_TRACK_SHORTCUT 305
#define LNG_DLGID3TAG_TRACE_LOG 306
#define LNG_DLGID3TAG_ONLY_SELECTED_ITEM 307
#define LNG_DLGID3TAG_SEPARATOR 308
#define LNG_DLGID3TAG_FILE_FORMAT 309
#define LNG_DLGID3TAG_OPTION 310
#define LNG_DLGID3TAG_BTN_REMOVEID3V1 311
#define LNG_DLGID3TAG_BTN_REMOVEID3V2 312
#define LNG_DLGID3TAG_BTN_REMOVEID3V1_2 313
#define LNG_DLGID3TAG_DIRECTORY 314
#define LNG_DLGID3TAG_TARGET 315
#define LNG_DLGID3TAG_BTN_MOVEUP 316
#define LNG_DLGID3TAG_BTN_MOVEDOWN 317
#define LNG_DLGID3TAG_BTN_SELECTALL 318
#define LNG_DLGID3TAG_BTN_NONE 319
#define LNG_SEARCH 320
#define LNG_PROGRESS_COMPLETE 321
#define LNG_HEADER_VOLUMENAME 322
#define LNG_HEADER_TOTALFILE 323
#define LNG_HEADER_TYPE 324
#define LNG_DRIVE_UNKNOWN  325
#define LNG_DRIVE_REMOVABLE 326
#define LNG_DRIVE_FIXED  327
#define LNG_DRIVE_CDROM  328
#define LNG_DRIVE_OTHER  329
#define LNG_DRIVE_RAMDRIVE 330
#define LNG_DRIVE_NETWORK 331
#define LNG_OPTIONEXPLORER_TITLE 332
#define LNG_OPTIONEXPLORER_FRAME 333

#endif // !defined(AFX_LANGUAGE_H__205B0701_EB94_11D3_816D_00000100CF13__INCLUDED_)
