/*****************************************************************************
    
	  SPECIFICATION ET AJOUT JLB 2002 CDriveVolumeInfo
		
		  This file is part of MP3ext.
    Copyright (C) 1999  Michael Mutschler

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    email: michael@mutschler.de
******************************************************************************/
// MP3MultiInfo.h: interface for the MP3MultiInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MP3MULTIINFO_H__F5F94643_30F2_11D1_AF88_080000051171__INCLUDED_)
#define AFX_MP3MULTIINFO_H__F5F94643_30F2_11D1_AF88_080000051171__INCLUDED_

#include "priv.h"
#include "MP3Info.h"


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct tagDriveVolume
{
	TCHAR szName[MAX_PATH+100];
	TCHAR szRootDrive[MAX_PATH];
	TCHAR szDescription[MAX_PATH];
	DWORD dwSerialNumber;
	int nCountFile;
	int nTypeMedia;

} DRIVEVOLUMESTRUCT;



class MP3MultiInfo  
{
public:
	MP3MultiInfo();	// set here the size of the array
	virtual ~MP3MultiInfo();
	void ResetAll();		

private:
	typedef vector<CMP3Info *> MArray;
	MArray MP3InfoArray;

	typedef vector<DRIVEVOLUMESTRUCT*> VolArray;
	VolArray m_DriveInfoArray;	// Vector Drive Volume

	int m_CurrentDriveIndex;
	

public:
// functions to access the array
	void DeleteInfo(int index);
	void ResetList();
	int AddInfo(CMP3Info *mp3i);		// true if anything changed
	int AddInfoQuick(CMP3Info *mp3i);	// without search the good Volumedrive
	int ReplaceInfo(int index, CMP3Info *mp3i);
	CMP3Info *GetInfo(int index) {return(index<MP3InfoArray.size()?MP3InfoArray[index]:NULL);};
	CMP3Info * operator [] (int index) {return(GetInfo(index));};
	int FindInfo(CMP3Info *mp3i);
	int GetCount() {return MP3InfoArray.size();};

// functions to acces the array "DriveVolumeInfo"
	void DeleteInfoDriveVolume(int index);
	void ResetListDriveVolume();
	int ReplaceInfoDriveVolume(int index, DRIVEVOLUMESTRUCT *dvs);
	int AddInfoDriveVolume(TCHAR *szVolumeDrive);
	int FindInfoDriveVolume(DWORD dwSerial);
	BOOL DeleteInfoDriveVolume(DWORD dwSerial);
	int GetCountDriveVolume()
		{return m_DriveInfoArray.size();}

	TCHAR* GetInfoDriveName(CMP3Info *mp3i);

	DRIVEVOLUMESTRUCT* GetInfoDriveVolume(int index); 
	BOOL SetDriveVolumeStruct(TCHAR *szVolumeDrive, DRIVEVOLUMESTRUCT *dvs);
	BOOL CheckRemoveableReady( LPTSTR lpszDriveName );

	void SetFileEZ3(DRIVEVOLUMESTRUCT* headerfile);  // EZPlaylist load EZ3 --> DRIVEVOLUMESTRUCT
	DRIVEVOLUMESTRUCT* GetFileEZ3(int index);		// DRIVEVOLUMESTRUCT --> EZPlaylist write EZ3
	
};



#endif // !defined(AFX_MP3MULTIINFO_H__F5F94643_30F2_11D1_AF88_080000051171__INCLUDED_)
