#include "ProgressBar.h"
#include "Language.h"


// external declaration
extern CLanguage    *lng;


#ifndef StatusBar_GetItemRect
#define StatusBar_GetItemRect(hWnd, iPart, lpRect) \
    SendMessage(hWnd, SB_GETRECT, (WPARAM) iPart, (LPARAM) (LPRECT) lpRect)
#endif

#define PART_WIDTH 150

// ***********************************************************
CProgressBar::CProgressBar(HWND hParent, HWND hStatusBar)
{
	m_hParent = hParent;
	m_hStatusBar = hStatusBar;
}

// ***********************************************************
void CProgressBar::Init(HINSTANCE hInst, int nCount)
{
    RECT rect;
	

	m_nCount = nCount;
	
    StatusBar_GetItemRect(m_hStatusBar, 0, &rect);

    rect.left += PART_WIDTH;

    m_hProgress = CreateWindowEx(WS_EX_STATICEDGE,
            PROGRESS_CLASS,
            _T("Progress Bar"),
            WS_CHILD | PBS_SMOOTH,
            rect.left,
            rect.top,
            rect.right - rect.left,
            rect.bottom - rect.top,
            m_hParent,
            NULL,
            hInst,
            NULL);
}

// ***********************************************************
void CProgressBar::Show()
{
    RECT rect;
	RECT rectParent;
    int  widths[2] = {PART_WIDTH, -1};

	// Eviter la division par Zero
	if (m_nCount == 0)
		m_nCount = 1;

    if (m_nCount < 100)
        m_nProgBarStep = 100 / m_nCount;
    else
        m_nProgBarStep = (m_nCount / 100);

    SendMessage(m_hStatusBar, SB_SETPARTS, (WPARAM) 2, (LPARAM) (LPINT) widths);
    
    SendMessage(m_hProgress, PBM_SETRANGE, 0, (LPARAM) MAKELONG(0, m_nCount));
    SendMessage(m_hProgress, PBM_SETSTEP, (WPARAM)m_nProgBarStep, 0);
    SendMessage(m_hProgress, PBM_SETPOS, 0, 0);


	TCHAR szTmp[] = _T(" ");
	SendMessage(m_hStatusBar, SB_SETTEXT, 0, (LPARAM)szTmp);
	SendMessage(m_hStatusBar, SB_SETTEXT, 1, (LPARAM)szTmp);


    StatusBar_GetItemRect(m_hStatusBar, 1, &rect);
	GetClientRect(m_hParent, &rectParent);

    MoveWindow(m_hProgress, rect.left, rectParent.bottom - (rect.bottom - rect.top),
        rect.right - rect.left, rect.bottom - rect.top, TRUE);
}

// ***********************************************************
void CProgressBar::StepIt(int nIndex)
{
    if ((nIndex % m_nProgBarStep) == 0)
	{
		TCHAR szTmp[80];
		_stprintf(szTmp, GS(LNG_PROGRESS_COMPLETE), ((nIndex + 1) * 100) / m_nCount);
    
		SendMessage(m_hStatusBar, SB_SETTEXT, 0, (LPARAM)szTmp);
    
		if (nIndex == 0)
			ShowWindow(m_hProgress, SW_SHOW);
        
		SendMessage(m_hProgress, PBM_STEPIT, 0, 0);
	}
}

