/*****************************************************************************
    This file is part of EZPlaylist for Winamp.
    Copyright (C) 2000-2001 Jean-louis BOYER

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    email: boyerjl@club-internet.fr
******************************************************************************/
// Misc Functions, no classes

#ifndef _MPG123_H
#define _MPG123_H

#include <ctype.h>
#include <windows.h>		// only for the LPCTSTR definition....
/***************************************************************************/
/* Definitions for MP3.c */
struct mpg123info
{
//	int jsbound;
//	int single;
//	int II_sblimit;
//	int down_sample_sblimit;
//	int down_sample;
//	int header_change;
	
	int filesize;

	int stereo;
	int lsf;
	int mpeg25;
	int lay;
	int error_protection;
	int sampling_frequency;
	int bitrate_index;
	BOOL varbitrate;		// true, if bitrate is variable XING
	unsigned long num_frames;
	int length;
	int padding;
	int extension;
	int mode;
	int mode_ext;
	int copyright;
	int original;
	int emphasis;
	int framesize;		/* computed framesize */
};

#ifndef CGLOBAL
#  ifdef __cplusplus
#    define CGLOBAL extern "C"
#  else
#     define CGLOBAL extern
#  endif
#endif

CGLOBAL void mpg123_readinfo(const TCHAR *filename, struct mpg123info * frm, BOOL id3_found);

CGLOBAL TCHAR *ModeName[4];
CGLOBAL TCHAR *BoolName[2];
CGLOBAL TCHAR *EmphasisName[4];
CGLOBAL TCHAR *ID3TagName[4];


#endif
