#include "priv.h"
#include "gen.h"
#include "definition.h"
#include "settings.h"
#include "Language.h"


// external declaration
extern winampGeneralPurposePlugin plugin;
extern CLanguage    *lng;
extern INITSTRUCT gParam;



COLUMNSSTRUCT gDefault_column[COLUMN_MAX]=
{	
	//  Name  Order Shown  Width,   Alignement    Is ID3 ? 
	{ NULL,   0,    1,     120,     LVCFMT_LEFT  ,1},   // ARTIST
	{ NULL,   1,    1,     160,     LVCFMT_LEFT  ,1},   // TITLE
	{ NULL,   2,    1,      85,     LVCFMT_LEFT  ,1},   // GENRE
	{ NULL,   3,    1,      45,     LVCFMT_LEFT  ,1},   // YEAR
	{ NULL,   4,    1,     160,     LVCFMT_LEFT  ,1},   // ALBUM
	{ NULL,   5,    1,     160,     LVCFMT_LEFT  ,1},   // COMMENT
	{ NULL,   6,    1,      75,     LVCFMT_LEFT  ,0},   // MODE
	{ NULL,   7,    1,      90,     LVCFMT_RIGHT ,0},   // BITRATE
	{ NULL,   8,    1,      70,     LVCFMT_LEFT  ,0},   // FREQ
	{ NULL,   9,    1,     100,     LVCFMT_LEFT  ,0},   // LAYER
	{ NULL,  10,    1,      50,     LVCFMT_RIGHT ,0},   // TIME
	{ NULL,  11,    1,      80,     LVCFMT_RIGHT ,0},   // SIZE
	{ NULL,  12,    1,     400,     LVCFMT_LEFT  ,0},   // FILENAME
	{ NULL,  13,    1,      60,     LVCFMT_RIGHT ,1},   // TRACK
	{ NULL,  14,    1,      80,     LVCFMT_LEFT  ,0},   // ID3TAG
	{ NULL,  15,    1,      60,     LVCFMT_LEFT  ,1},   // BPM
	{ NULL,  16,    0,      80,     LVCFMT_LEFT  ,0}    // HEADER_VOLUMENAME
};

TEMPLATESTRUCT gaTemplateDefault[MAX_TEMPLATE]=
{
	// Standard 
	{0x00000000, 0x00FFFFFF, 1,0,1,	// CSS1:Text color, background color, Font name, FontStyle, FontSize
		0x00000000, 0x00FFFFFF, 1,1,6,
		0x00000000, 0x00C0C0C0, 1,1,2,	// Attention au codage de la couleur
		0x00000000, 0x00FFFFFF, 1,0,1,  // RGB stockee --> 0x00BBGGRR (inversee)
		0x00FF0000},
	// Winamp
	{0x0000BFFF, 0x00400000, 0,0,1,
		0x0000BFFF, 0x00400000, 0,1,5,
		0x00400000, 0x0000BFFF, 0,1,3, 
		0x00FFFFFF, 0x00400000, 0,0,0, 
		0x00FF9F40},
	// BigBlue
	{0x00505050, 0x00C0C0C0, 1,1,1,
		0x00000000, 0x00B09890, 1,1,1,
		0x00FFFFFF, 0x00806450, 1,1,1, 
		0x00000000, 0x00B09880, 1,1,1, 
		0x00A00000},
	// Desert
	{0x0098CCE0, 0x00000040, 2,0,1,
		0x0098CCE0, 0x00000040, 2,1,5,
		0x00FFFFFF, 0x00000080, 2,0,1, 
		0x00000080, 0x0098CCE0, 2,0,1, 
		0x000000FF},
	// Rain Forest
	{0x00000000, 0x00737973, 0,0,1,
		0x00B5AA9C, 0x00000000, 0,1,5,
		0x009FA49F, 0x00655956, 0,1,3, 
		0x00000000, 0x009FA499, 0,0,0, 
		0x00732800},
	// Rain Forest
	{0x008F97A0,0x003F273F, 0,0,1,
		0x00FFFFFF, 0x00505F70, 0,1,5,
		0x00FFFFFF, 0x005F3F40, 0,1,3, 
		0x00000000, 0x008F97A0, 0,0,0, 
		0x00C0CFD0},
	// 
	{0x00FFFFFF, 0x00000000, 3,1,1,
		0x00000000, 0x00707070, 3,1,1,
		0x00FFFFFF, 0x003F3F3F, 3,1,1, 
		0x00B08F3F, 0x00000000, 3,1,1, 
		0x00B08F3F},
	// 
	{0x003F1F1F, 0x006F776F, 3,1,1,
		0x006F776F, 0x002F0800, 3,1,4,
		0x00000000, 0x00BFBFBF, 3,1,3, 
		0x00303F40, 0x006F776F, 3,1,1, 
		0x00402F30}

};		

// ************************************************************************
CSetting::CSetting()
{
	SetInifile();
}

// ************************************************************************
CSetting::~CSetting()
{
	;
}

// ************************************************************************
void CSetting::Init()
{
	DefaultColumnName();
	
	if (Load() == FALSE)
		Default();
}

// ************************************************************************
void CSetting::DefaultColumnName()
{
	gDefault_column[0].szName  = GS(LNG_ARTIST);  
	gDefault_column[1].szName  = GS(LNG_TITLE);   
	gDefault_column[2].szName  = GS(LNG_GENRE);   
	gDefault_column[3].szName  = GS(LNG_YEAR);    
	gDefault_column[4].szName  = GS(LNG_ALBUM);   
	gDefault_column[5].szName  = GS(LNG_COMMENT); 
	gDefault_column[6].szName  = GS(LNG_MODE);    
	gDefault_column[7].szName  = GS(LNG_BITRATE); 
	gDefault_column[8].szName  = GS(LNG_FREQ);    
	gDefault_column[9].szName  = GS(LNG_LAYER);   
	gDefault_column[10].szName = GS(LNG_TIME);    
	gDefault_column[11].szName = GS(LNG_SIZE);    
	gDefault_column[12].szName = GS(LNG_FILENAME);
	gDefault_column[13].szName = GS(LNG_TRACK);   
	gDefault_column[14].szName = GS(LNG_ID3TAG);  
	gDefault_column[15].szName = GS(LNG_BPM); 
	gDefault_column[16].szName = GS(LNG_HEADER_VOLUMENAME);
}

/* ************************************************************************ */
void CSetting::Default()
{
	ResetHTML();	
	ResetColumn();
	ResetID3Tools();	
	ResetOption();
}

/* ************************************************************************ */
void CSetting::SetInifile()
{
	TCHAR *p;
	
	m_szIniFile[0] = 0;

	GetModuleFileName(plugin.hDllInstance,m_szIniFile,MAX_PATH*sizeof(TCHAR));
	p = m_szIniFile + _tcslen(m_szIniFile);
	while (p >= m_szIniFile && *p != '\\') p--;
	if (++p >= m_szIniFile) *p = 0;
	_tcscat(m_szIniFile, _T("gen_EZPlaylist.ini"));

	return;
}

/* ************************************************************************ */
bool CSetting::Load()
{
	FILE *file;		

	if ( (file = _tfopen(m_szIniFile, _T("rb"))) == NULL)
		return FALSE;

	if (fread(&gParam, 1, sizeof(INITSTRUCT), file) != sizeof(INITSTRUCT))
	{
		fclose(file);
		return FALSE;
	}
	
	fclose(file);
	return TRUE;
}



/* ************************************************************************ */
bool CSetting::Save()
{
	FILE *file;		

	if ( (file = _tfopen(m_szIniFile, _T("wb"))) == NULL)
		return FALSE;

	fwrite (&gParam, sizeof(INITSTRUCT), 1, file);
	fclose(file);
	return TRUE;
}

// *******************************************************************
void CSetting::ResetHTML()
{
	int i,j;
	
	gParam.nCurrentTemplate = 0;
	
	for (i=0; i<MAX_TEMPLATE; i++)
	{
		gParam.Template[i].cLinkColor = gaTemplateDefault[i].cLinkColor;
	
		for (j=0;j<MAX_CSS;j++)
		{
			gParam.Template[i].css[j].cColor     = gaTemplateDefault[i].css[j].cColor;
			gParam.Template[i].css[j].cColorBack = gaTemplateDefault[i].css[j].cColorBack;
			gParam.Template[i].css[j].nFontName  = gaTemplateDefault[i].css[j].nFontName; 
			gParam.Template[i].css[j].nFontStyle = gaTemplateDefault[i].css[j].nFontStyle;
			gParam.Template[i].css[j].nFontSize  = gaTemplateDefault[i].css[j].nFontSize;
		}
	}
}

// *******************************************************************
void CSetting::ResetColumn()
{
	gParam.sort_reverse = 0;
	gParam.sort_column  = 0;
	gParam.bShowNumber  = 0;
	gParam.bShowGrid    = 0;
	gParam.nShowID3v1   = 0;
		
	for (int i=0; i<COLUMN_MAX; i++)
	{
		gParam.column_order[i] = gDefault_column[i].nOrder;
		gParam.column_width[i] = gDefault_column[i].nWidth;
		gParam.column_shown[i] = gDefault_column[i].nShown;
	}
}

// *******************************************************************
void CSetting::ResetID3Tools()
{
	for (int i = 0; i<MAX_COL_FRMT; i++) 	
		gParam.FrmtCol[i] = -1;

	gParam.FrmtCol[0] = 0;	// Uniquement Artiste et Titre
	gParam.FrmtCol[1] = 1;
	
	gParam.nMassCheckTAG     = 0;
	gParam.nMassTagID3       = 3;
	gParam.nWriteTagfromFile = 3;
	gParam.nRenameFileFromTagWithID3v1 = 1;
	gParam.nOptionCapitalize = 0;
	gParam.nOptionConvert    = 0;
	gParam.nOrganizeFromID3  = 0;
	gParam.nOrganizeField    = 0;
	_tcscpy(gParam.szSep, _T(" - "));
}

// *******************************************************************
void CSetting::ResetOption()
{
	gParam.bExportAllItems	  = 0;
	gParam.bExportHTML_Format =	0;
	gParam.bExportHTML_Link   = 0;
	gParam.nOptionSearch      = 31;
	gParam.nDblClic           = 0;
	gParam.nOnStartup         = 0;
	gParam.bExportBothID3     = 0;
	gParam.bShowNumber        = 0;
	gParam.bShowGrid          = 0;
	gParam.nMatchTime         = 0;

	// Window placement 
	gParam.wp.length          = sizeof(WINDOWPLACEMENT);
    gParam.wp.flags           = WPF_RESTORETOMAXIMIZED | WPF_SETMINPOSITION; 
    gParam.wp.showCmd         = SW_SHOWNORMAL;  
    gParam.wp.ptMinPosition.x = 10; 
    gParam.wp.ptMinPosition.y = 10; 
	gParam.wp.ptMaxPosition.x = 10; 
    gParam.wp.ptMaxPosition.y = 10; 
    gParam.wp.rcNormalPosition.left   = 10; 
	gParam.wp.rcNormalPosition.top    = 10; 
	gParam.wp.rcNormalPosition.right  = 600; 
	gParam.wp.rcNormalPosition.bottom = 400; 

	gParam.nTypeDuplicate     = 0;
	gParam.nDuplicateTime     = 5;	 //5 sec
	gParam.nDuplicateFilesize = 95;  //95%
	_tcscpy(gParam.szLanguage, _T("English(Default"));
	gParam.nOptionExplorer = 63;
}
